/* *******************************************************
 * ThreadArcs.js
 *
 * (c) 2005 Alexander C. Hubmann
 *
 * JavaScript file for Mozilla part of ThreadArcs Extension
 *
 * Version: $Id: ThreadArcs.js 79 2005-04-13 15:13:00Z sascha $
 ********************************************************/

var HTML_NAMESPACE =
    "http://www.w3.org/1999/xhtml";

var XUL_NAMESPACE =
    "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

// add applet at startup
window.setTimeout(addThreadArcsApplet, 1000);

var loaded = false;
// FIXXME: hack
// add messages when we display first header
var doLoad = {
    onStartHeaders: function()
    {
        if (! loaded)
            addMessages();
        loaded = true;
        setSelectedMessage();
    },
    onEndHeaders: function()
    {
    }
}
gMessageListeners.push(doLoad);


/**
 * Add all messages from current account
 */
function addMessages()
{
    // get root folder
    var folder = GetLoadedMsgFolder();
    var root = folder.rootFolder;

    addMessagesFromSubFolders(root);
        
    getApplet().thread();
}

/**
 * Add all messages from subfolders
 */
function addMessagesFromSubFolders(folder)
{
    //alert("addMessagesFromSubFolders(" + folder.name + ")");
    var folder_enumerator = folder.GetSubFolders();
    var current_folder = null;
    while (true)
    {
        //alert("Trying to get current folder");
        try
        {
            current_folder = folder_enumerator.currentItem();
        }
        catch (Exception)
        {
            //alert("break");
            break;
        }
        
        //alert(current_folder);
        //alert(current_folder.name);
        if (current_folder instanceof Components.interfaces.nsIMsgFolder)
            addMessagesFromFolder(current_folder);
        
        if (current_folder.hasSubFolders)
            addMessagesFromSubFolders(current_folder);    
        
        try
        {
            //alert("trying to get next folder");
            folder_enumerator.next();
        }
        catch (Exception)
        {
            //alert("break");
            break;
        }
    }
    //alert("addMessagesFromSubFolders() returns");
}

/**
 * Add all messages in this folder
 */
function addMessagesFromFolder(folder)
{
    //alert("addMessagesFromFolder(" + folder.name + ")");
    // get messages from current folder
    var msg_enumerator = folder.getMessages(null);
    var header = null;
    while (msg_enumerator.hasMoreElements())
    {
        header = msg_enumerator.getNext();
        if (header instanceof Components.interfaces.nsIMsgDBHdr)
        {
            var date = new Date();
            // PRTime is in microseconds, Javascript time is in milliseconds
            // so divide by 1000 when converting
            date.setTime(header.date / 1000);
            date = date.getDate() + ". " + date.getMonth() + ". " + date.getFullYear() + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
            getApplet().addMessage(header.subject, header.author, header.messageId, header.messageKey, date, header.folder.URI , header.getStringProperty("references"));
        }
    }
    //alert("addMessagesFromFolder() returns");
}


/**
 * Add the applet to the user interface
 * Has to be done at runtime to determine classpath
 */
function addThreadArcsApplet()
{
    // create the dom object
    var applet = document.createElementNS( HTML_NAMESPACE, "applet" );

    // set default attributes
    applet.setAttribute( "id", "ThreadArcsApplet" );
    applet.setAttribute( "code", "ThreadArcsApplet.class" );
    var archive = "ThreadArcs.jar";
    applet.setAttribute( "archive", archive );
    applet.setAttribute( "align", "baseline" );

    // get the run time codebase to the java classes
    var codebase = getCodeBase();
    //applet.setAttribute( "codebase", codebase + "ThreadArcs" );
    applet.setAttribute( "codebase", codebase);
    applet.setAttribute( "collapsed", "false" );
    applet.setAttribute( "width", "200" );
    applet.setAttribute( "height", "50" );
    applet.setAttribute( "MAYSCRIPT", "true" );

    // apply to this dom object
    var box = document.getElementById( "ThreadArcsBox" );
    box.appendChild( applet );
    
    setUnloadHandler();
}


/**
 * Add unload handler, so that we can destroy the Java-Applet
 * before closing the application.
 */
function setUnloadHandler()
{
    var headerViewElement = document.getElementById("msgHeaderView");
    headerViewElement.addEventListener("messagepane-unloaded", unloadHandler, false);
}


/**
 * Unload-Handler. Called before Messenger-Window is closed.
 * Remove applet node from userinterface.
 * Otherwise Mozilla does not quit sometimes and only closes the window.
 */
function unloadHandler()
{
    var applet = getApplet();
    applet.parentNode.removeChild(applet);
}


/**
 * Get DOM object of applet
 */
function getApplet() {

    return document.getElementById( "ThreadArcsApplet" );
}


/**
 * Get codebase to java classes
 */
function getCodeBase()
{
    var dirServ = Components.classes[ "@mozilla.org/file/directory_service;1" ].getService();
    dirServ = dirServ.QueryInterface(Components.interfaces.nsIProperties);
    
    var file = dirServ.get( "ComsD", Components.interfaces.nsIFile );
    
    var ioserv = Components.classes["@mozilla.org/network/io-service;1"].getService();
    ioserv = ioserv.QueryInterface(Components.interfaces.nsIIOService);
    
    var fileURL = ioserv.newFileURI( file );
    
    return fileURL.spec;
}


/**
 * Called when a message is selected
 * Call applet with messageid to visualsse
 */
function setSelectedMessage()
{
    // get currently loaded message
    var msg_uri = GetLoadedMessage();
    var msg = messenger.messageServiceFromURI(msg_uri).messageURIToMsgHdr(msg_uri);
    // call applet
    getApplet().visualise(msg.messageId);
}


/**
 * Callback function from applet
 * called after mouse click in applet
 * select message in mail view
 */
function threadArcsCallback(msgKey, folder)
{
    // get folder for message
    //var current_folder = GetLoadedMsgFolder();
    //var root = current_folder.rootFolder;
    //var folder = root.FindSubFolder(folder);
    //alert("found folder: " + folder.URI);
    //SelectFolder(folder.URI);
    SelectFolder(folder);
    
    // clear current selection
    var treeBoxObj = GetThreadTree().treeBoxObject;
    var treeSelection = treeBoxObj.selection;
    treeSelection.clearSelection();
    
    // select message
    gDBView.selectMsgByKey(msgKey);
    
    treeBoxObj.ensureRowIsVisible(treeSelection.currentIndex);
}